SystemOrganization addCategory: #'Seaside28Jetsam-Helpers-Rendered'!
SystemOrganization addCategory: #'Seaside28Jetsam-Helpers-Session'!
SystemOrganization addCategory: #'Seaside28Jetsam-Helpers-Configuration'!

!WADispatcher methodsFor: '*js-helpers' stamp: 'kph 12/10/2007 15:34'!
postProcessRequest: aRequest returned: response
	
	| handler key |
	
	handler := self handlerForRequest: aRequest.
	key := response fieldAt: 'Session' ifAbsent: [ ^ nil ].
	
	handler isApplication ifFalse: [ ^ self ].
	handler :=  handler handlersByKey at: key ifAbsent: [ ^ nil ].
	 
	handler ifNil: [ ^ self ].
	handler isActive ifFalse: [ ^ self ].
	
	handler postProcessRequest: aRequest returned: response
		
 ! !

!WAApplication methodsFor: '*js-helpers' stamp: 'kph 10/27/2007 21:02'!
application
	^ self  ! !

!WAApplication methodsFor: '*js-helpers-override' stamp: 'kph 10/29/2007 04:37'!
handleDefaultRequest: aRequest
	"restoring the application: instanciation method, it is important that 
	setParent: is called before initialize, as all instanciation set methods should be!!"
	
	^ (self sessionClass application: self) handleRequest: aRequest! !

!WAApplication methodsFor: '*js-helpers' stamp: 'kph 12/8/2007 05:16'!
postProcessRequest: aRequest returned: aResponse

	^ (self sessionClass application: self) postProcessRequest: aRequest returned: aResponse! !

!WAConfiguration methodsFor: '*js-helpers' stamp: 'kph 12/9/2007 04:37'!
commentForAttribute: anAttribute  
	| selector |
 
	self inheritedValueAndSourceAt: anAttribute key do: [ :value :source |
		selector := ('comment', anAttribute key capitalized, ':config:') asSymbol.
		
		(source respondsTo: selector) ifTrue: [ ^ source perform: selector with: (self valueForAttribute: anAttribute) with: self ]
	].
	
	^ nil! !

!WAConfiguration methodsFor: '*js-helpers' stamp: 'kph 7/19/2007 11:28'!
hasGroupNamed: aSymbol
	^ self allAttributes anySatisfy: [:ea | ea group = aSymbol]! !

!WAKom methodsFor: '*js-helpers-override' stamp: 'kph 12/8/2007 05:03'!
handleRequest: aRequest
	 HttpAdaptor current addPostProcessor: [ :request :response | entryPoint postProcessRequest: request returned: response ].
	 ^ entryPoint handleRequest: aRequest! !

IdentityDictionary subclass: #WASessionHelpers
	instanceVariableNames: 'parent session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Session'!

!WASessionHelpers commentStamp: 'kph 12/9/2007 01:46' prior: 0!
Since WASession does not have a properties dictionary for flexible use, we provide a general purpose propteries container and we use this to support additional helper items for sessions.  

"The end may justify the means as long as there is something that justifies the end." -- Leon Trotsky

We maintain a back-link to the session for which our helpers are helping. If a helper wishes to work in collaboration with other helpers, it is able to hold a reference to the session or to us.!

!WASessionHelpers class methodsFor: 'as yet unclassified' stamp: 'kph 12/11/2007 15:55'!
parent: aRequestHandler session: aSeasideSession

	^ self basicNew setParent: aRequestHandler session: aSeasideSession! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 12/17/2007 20:47'!
actAsExecutor

	"since the session is likely to be the item registered for finalization, we must avoid holding on to references to it"
	session := nil.
	self keysAndValuesDo: [ :key :value | 
		value species == WASessionHelper ifTrue: [ self at: key put: value executor ]
	]! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 18:18'!
application
	^ parent! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 12/17/2007 20:47'!
helpersDo: aBlock

	self do: [:each | each species == WASessionHelper ifTrue: [ aBlock value: each ] ]
	! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 01:44'!
incomingRequest: aRequest in: aSession

	self helpersDo: [ :each | 
		  (each incomingRequest: aRequest in: aSession) ifNotNilDo: [ :response | ^ response ]  
	].
	
	^ nil! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 10/28/2007 23:42'!
initialize
	super initialize: 5.
	WASessionHelper addHelpersTo: self! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 01:43'!
postProcessRequest: aRequest returned: aResponse

	self helpersDo: [ :each | each postProcessRequest: aRequest returned: aResponse ]! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 12/17/2007 20:47'!
responseForRequest: aRequest wrap: aBlock

	"each helper gets the block which it can wrap, returning another block"
	
	| wrappedBlock |
	wrappedBlock := self inject: aBlock into: [ :block :each  | 
		each species == WASessionHelper ifTrue: [ each responseForRequest: aRequest wrap: block ] ifFalse: [ block ] 
	].
	
 	^ wrappedBlock value! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 22:12'!
session
	^ session! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 22:10'!
setParent: p session: s

	parent := p.
	session := s.! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 01:42'!
unregistered

	self helpersDo: [:each |  each unregistered ] ! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 01:50'!
updateRoot: aHtmlRoot

	self helpersDo: [ :each | each updateRoot: aHtmlRoot ]! !

WADecoration subclass: #WAHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Rendered'!

!WAHelper commentStamp: 'kph 10/27/2007 02:59' prior: 0!
Helpers are decorations that automatically have the opportunity to be added to #createRoot:

Additional helpers can be added via subclassing without needing to override methods (#createRoot) that are already overriden.!

WAHelper subclass: #ShoreHelperHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Rendered'!

!ShoreHelperHelper commentStamp: 'kph 11/4/2007 02:25' prior: 0!
This helper provides the support needed for Shore Components. It renders a number of elements which shore uses on every page.!

!ShoreHelperHelper class methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 02:50'!
isEnabledFor: application

	^ (application preferenceAt: #enableShoreHelper) ifNil: [ false ]! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 02:04'!
processChildCallbacks: aStream

	self variableShoreCurrentRoot use: self component during: [ super processChildCallbacks: aStream ]
! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 01:37'!
renderContentOn: html

	self renderOwnerOn: html.
	
	html div id: #shoreModalDialogOverlay; class: #hidden.

	html div id: #shoreProgressOverlay; class: #hidden.
	html div id: #shoreProgressSpinner; class: #hidden; with: [
		html image url: ('spinner.gif' asShoreUrl) ].

	html div id: #shoreModalDialogBox; class: #hidden;
		with: [ 
			html div id: #shoreModalDialogBoxHeader; with: [].
			html div id: #shoreModalDialog].

	html div id: #shoreContextMenu; class: #hidden; with: [
		html div id: #shoreContextMenuContent].

	html script: 'shoreResizeHandler(null);'.

! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 03:41'!
renderOwner: owner withShoreContext: aRenderingContext

 	
	| html callbacks |
	callbacks := aRenderingContext callbacksFor: self.
	html := self rendererClass context: aRenderingContext callbacks: callbacks.
	(owner showHalo and: [ aRenderingContext isDebugMode ])
		ifTrue: [ (WAHalo for: owner) renderContentOn: html ]
		ifFalse: [ owner renderContentOn: html  ].
	html flush	
! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 03:50'!
renderOwnerOn: html
	self owner ifNotNilDo: [:owner | 
		
		self variableShoreCurrentRoot use: self during: [
			
			owner renderWithContext: html context
			
		]
	].
	
! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 01:59'!
rendererClass

	^ Smalltalk at: #ShoreCanvas! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 02:02'!
variableShoreCurrentRoot

	^ Smalltalk at: #ShoreCurrentRoot! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 02:02'!
variableShoreCurrentTarget

	^ Smalltalk at: #ShoreCurrentTarget! !

WAHelper subclass: #WAEventHelper
	instanceVariableNames: 'parents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Rendered'!

!WAEventHelper commentStamp: 'kph 11/4/2007 02:28' prior: 0!
EventHelper records the parents of each component rendered which WAComponent should do anyway.
 
This allows event handlers to propagate up the heirarchy properly.!

!WAEventHelper class methodsFor: 'as yet unclassified' stamp: 'kph 11/5/2007 23:40'!
isEnabledFor: app

^ false! !

!WAEventHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/4/2007 02:28'!
renderContentOn: html

	parents := IdentityDictionary new.
	self renderOwnerOn: html.
	! !

!WAHelper class methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:10'!
helpersFor: application addTo: rootComponent 

	"each helper has the opportunity to nominate an alternative root component or nil"
	| newRoot |

	self allSubclasses do: 
			[:each | 
			(each isEnabledFor: application) 
				ifTrue: [ newRoot := each new addDecorationTo: rootComponent]].
	^ newRoot ifNil: [ rootComponent ].! !

!WAHelper class methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 02:49'!
isEnabledFor: application

	self subclassResponsibility! !

!WAHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:12'!
addDecorationTo: rootComponent

	"double-dispatch missing from WADecoration"
	rootComponent addDecoration: self.
	
	"IMPORTANT - return the root component or a substitute root"
	
	^ rootComponent! !

WAHelper subclass: #WAKeepSessionAliveHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Rendered'!

!WAKeepSessionAliveHelper commentStamp: 'kph 11/4/2007 02:24' prior: 0!
This helper appends a script to the root component which prevents the users session from expiring if their browser window is still open.!

!WAKeepSessionAliveHelper class methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 03:16'!
isEnabledFor: application
	 
	^ (application preferenceAt: #keepSessionAlive) ifNil: [ false ]
	
! !

!WAKeepSessionAliveHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 03:17'!
renderContentOn: html

	self renderOwnerOn: html.
	 
     html script: (html request
       				every: (self preferenceAt: #sessionExpirySeconds) - 60).
! !

WAHelper subclass: #WAToolbarHelper
	instanceVariableNames: 'frame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Rendered'!

!WAToolbarHelper commentStamp: 'kph 11/10/2007 00:23' prior: 0!
The toolbar helper provides the toolbar when in deployment mode if the user session returns true from #showToolBarHelper

The toolbar's terminate action also works although it is disabled normally.

!

!WAToolbarHelper class methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:58'!
isEnabledFor: application
	 
	^ (application preferenceAt: #enableToolbarHelper) ifNil: [ false ]
	
! !

!WAToolbarHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:23'!
addDecorationTo: rootComponent

	super addDecorationTo: rootComponent.
	 
	"we could substitute the toolbar frame for the root here"
	^ rootComponent! !

!WAToolbarHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:46'!
getToolFrame

	^ frame := self isToolbarEnabled ifFalse: [ nil ] ifTrue: [ frame ifNil: [ self initializeToolFrame ] ]! !

!WAToolbarHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:31'!
initializeToolFrame

	^ WAToolFrame on: self component! !

!WAToolbarHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/10/2007 00:21'!
isToolbarEnabled
	
	| session | 
	
	(session := self session) application deploymentMode ifFalse: [ ^ false ].
	
	^ session showToolbarHelper ! !

!WAToolbarHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:55'!
processCallbackStream: aCallbackStream

	frame ifNil: [ ^ super processCallbackStream: aCallbackStream ].
	
	frame processTimeBegin.
	
	frame withDeprecatedHandlerDo: [ super processCallbackStream: aCallbackStream ]! !

!WAToolbarHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:45'!
renderContentOn: html

	self getToolFrame ifNil: [ ^ self renderOwnerOn: html ].
	
	frame on: html frameThis:  [ self renderOwnerOn: html ]. 
	 
	frame renderToolbarOn: html.
	! !

!WAConfigurationEditor methodsFor: '*js-helpers-override' stamp: 'kph 12/9/2007 04:37'!
renderAttribute: anAttribute on: html
	html tableRow: [
		html tableData: (self labelForSelector: anAttribute key).
		html tableData: [
			(configuration valueForAttribute: anAttribute)
				ifNil: [ self renderUnspecifiedAttribute: anAttribute on: html ]
				ifNotNil: [
					(configuration hasLocalValueForAttribute: anAttribute)
						ifTrue: [ self renderOverridenAttribute: anAttribute on: html ]
						ifFalse: [ self renderInheritedAttribute: anAttribute on: html ] ] ].
		self renderInheritanceForAttribute: anAttribute on: html ].
	(configuration commentForAttribute: anAttribute)
		ifNotNilDo: [ :comment |
						html tableRow:
							   [ html tableData: [].
								html tableData colSpan: 3; with: [ html small: [ html html: comment ] ] ]
		]
	! !

!WAToolFrame methodsFor: '*js-helpers' stamp: 'kph 11/9/2007 23:43'!
on: html frameThis: aBlock

	self showHalos
		ifTrue: [ html context debugMode ].

	self timeThis: [ self withDeprecatedHandlerDo: aBlock ].
	
	html context clearMode! !

!WAToolFrame methodsFor: '*js-helpers' stamp: 'kph 11/9/2007 23:54'!
processTimeBegin
	processTime := Time millisecondClockValue.! !

!WAToolFrame methodsFor: '*js-helpers' stamp: 'kph 11/9/2007 23:40'!
timeThis: aBlock
	processTime := processTime isNil
		ifTrue: [ 0 ]
		ifFalse: [ Time millisecondClockValue - processTime ].
		
	renderTime := Time millisecondsToRun: aBlock.
! !

Object subclass: #WASessionHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Session'!

WASessionHelper subclass: #WAAXAnnouncementsHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Session'!

!WAAXAnnouncementsHelper class methodsFor: 'as yet unclassified' stamp: 'kph 11/17/2007 00:58'!
helperKey

	^ #axannouncer! !

!WAAXAnnouncementsHelper class methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:27'!
isEnabledFor: application

	^ (application preferenceAt: #useAXAnnouncer) ifNil: [ false ]! !

!WAAXAnnouncementsHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:00'!
helperValue

	^ (Smalltalk at: #AXAnnouncer ifAbsent: 'AXAnnouncements package not loaded') new! !

WASessionHelper subclass: #WAAnnouncementsHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Session'!

!WAAnnouncementsHelper class methodsFor: 'as yet unclassified' stamp: 'kph 11/17/2007 00:58'!
helperKey

	^ #announcer! !

!WAAnnouncementsHelper class methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:27'!
isEnabledFor: application

	^ (application preferenceAt: #useAnnouncer) ifNil: [ false ]! !

!WAAnnouncementsHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:00'!
helperValue

	^ (Smalltalk at: #Announcer ifAbsent: 'Announcements package not loaded') new! !

WASessionHelper subclass: #WACometHelper
	instanceVariableNames: 'handlers session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Session'!

!WACometHelper class methodsFor: 'as yet unclassified' stamp: 'kph 11/17/2007 00:59'!
helperKey

	^ #comet! !

!WACometHelper class methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 21:18'!
isEnabledFor: application

	^ (application preferenceAt: #enableCometHelper) ifNil: [ false ]! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/11/2007 10:36'!
actAsExecutor

	"if you reference the seaside session it nust be nilled out here."
		super actAsExecutor.
		session := nil.! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 22:00'!
handlerClass
	^ Smalltalk at: #CTHandler ifAbsent: [ self error: 'comet package not loaded' ]! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 21:21'!
headerField
	^ '_c'! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 21:52'!
incomingRequest: aRequest in: aSession

	aRequest responseStream
		ifNil: [ self error: 'Streaming-server required to support Comet' ].

	^  (handlers at: (aRequest fields at: self headerField ifAbsent: [ ^ nil ]) ifAbsent: [ ^ nil ]) connect: aRequest ! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/16/2007 20:50'!
initialize
	handlers := Dictionary new! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 22:46'!
isRequestHandler

	^ true! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 22:17'!
registerPusher: aPusher context: aContext
	| handler |
	handler := self handlerClass on: aPusher session: session context: aContext.
	handlers at: handler id put: handler.
	^ handler id
 ! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/16/2007 20:51'!
setUp: helpers
	 	session := helpers session.! !

!WASessionHelper class methodsFor: 'as yet unclassified' stamp: 'kph 11/16/2007 20:49'!
addHelpersTo: helpers 
	self allSubclasses 
		do: [:each | (each isEnabledFor: helpers application) ifTrue: [each new addHelperTo: helpers; setUp: helpers ]].
	^ helpers! !

!WASessionHelper class methodsFor: 'as yet unclassified' stamp: 'kph 12/11/2007 09:37'!
doesNotUnderstand: aMessage

	aMessage selector isUnary ifTrue: [ ^ self forApp: aMessage selector ].
	
	^ super doesNotUnderstand: aMessage.
! !

!WASessionHelper class methodsFor: 'as yet unclassified' stamp: 'kph 12/11/2007 09:37'!
forApp: appName 

	"this gets you DIRECT command line access to the helper outside of browser
	with the configuration of the named application"
	
	^ (WASession forApp: appName) helpers at: self helperKey 
	 ! !

!WASessionHelper class methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 19:18'!
isEnabledFor: application 
	self subclassResponsibility! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/11/2007 10:36'!
actAsExecutor

	"if you reference the seaside session it nust be nilled out here."
	super actAsExecutor! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/28/2007 23:44'!
addHelperTo: helpers

	helpers at: self helperKey put: self helperValue! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/17/2007 00:57'!
helperKey

	^ self class helperKey! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 19:56'!
helperValue

	^ self! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 22:48'!
incomingRequest: aRequest in: aSession

	^ nil! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/16/2007 20:48'!
initialize
	"called before adding the helper to the session #setUp is called after"
 ! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 22:48'!
isSessionHelper

	^ true! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 03:00'!
performRequest: aRequest with: aBlock

	^ aBlock! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 05:22'!
postProcessRequest: aRequest returned: aResponse

	"This gets called AFTER Kom has sent the response to the browser"! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 05:29'!
responseForRequest: aRequest wrap: aBlock

	^ aBlock! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 02:51'!
setUp: helpers
 ! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/17/2007 20:46'!
species

	^ WASessionHelper! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/16/2007 20:00'!
tearDown! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/16/2007 19:59'!
unregistered
	"called at session expiry"
	self tearDown! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 01:51'!
updateRoot: aHtmlRoot

	"signals the start of rendering"! !

!WARenderLoopMain methodsFor: '*js-helpers-override' stamp: 'kph 10/27/2007 19:27'!
createRoot

	^ WAHelper helpersFor: self application addTo:  self rootClass new. 
	 ! !

WASystemConfiguration subclass: #WAHelperConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Configuration'!

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:28'!
attributeAXAnnouncer

	^ WABooleanAttribute key: #useAxAnnouncer group: #helpers! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:25'!
attributeAnnouncer

	^ WABooleanAttribute key: #useAnnouncer group: #helpers! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 21:19'!
attributeCometHelper

	^ WABooleanAttribute key: #enableCometHelper group: #helpers! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 03:10'!
attributeEnableShoreHelper

	^ WABooleanAttribute key: #enableShoreHelper group: #helpers! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:59'!
attributeEnableToolbarHelper

	^ WABooleanAttribute key: #enableToolbarHelper group: #helpers! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 03:11'!
attributeKeepSessionAlive

	^ WABooleanAttribute key: #keepSessionAlive group: #helpers! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 9/7/2007 14:50'!
attributes
	"thanks lukas"
	^ (self class selectors
		select: [ :each | each ~= #attributes
			and: [ each beginsWith: #attribute ] ])
		collect: [ :each | self perform: each ]! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 02:36'!
commentEnableCometHelper: value config: configuration
 
	^ value ifTrue: [ 'Comet support enabled for this application' ] ifFalse: [ 'enable to use Comet with this application' ]! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 02:36'!
commentEnableShoreHelper: value config: configuration
 
	^ value ifTrue: [ 'ShoreComponents enabled for this application' ] ifFalse: [ 'enable to use ShoreComponents in this application' ]! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 02:36'!
commentEnableToolbarHelper: value config: configuration
 
	^ value ifTrue: [ 'when deployed show toolbar for users with sessions having #showToolbarHelper flag set' ] ifFalse: [ 'enable to add toolbar for users with sessions having #showToolbarHelper flag set' ]! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 02:36'!
commentKeepSessionAlive: value config: configuration
 
	^ value ifTrue: [ 'add javascript to every page which keeps the seaside session alive while the users browser is open' ] ifFalse: [ 'enable to add javascript to every page which keeps the seaside session alive while the users browser is open' ]! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 02:37'!
commentUseAnnouncer: value config: configuration
 
	^ value ifTrue: [ 'sessions have #announcer' ] ifFalse: [ 'enable to add an Announcer to each Session' ]! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 02:37'!
commentUseAxAnnouncer: value config: configuration
 
	^ value ifTrue: [ 'sessions have #axannouncer' ] ifFalse: [ 'enable to add an AXAnnouncer to each Session' ]! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 21:19'!
enableCometHelper

	^ false! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 01:02'!
enableShoreHelper

	^ false! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 11/10/2007 01:50'!
enableToolbarHelper

	^ false! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 9/7/2007 14:53'!
keepSessionAlive

	^ false! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:26'!
useAnnouncer

	^ false! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:29'!
useAxAnnouncer

	^ false! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 12/11/2007 10:33'!
actAsExecutor

	super actAsExecutor.	
	parent := parent executor.
				
	^ self! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 10/27/2007 19:42'!
announcer
	^ self helpers at: #announcer! !

!WASession methodsFor: '*js-helpers-override' stamp: 'kph 10/27/2007 18:18'!
application
	^ parent application! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 10/27/2007 20:24'!
axannouncer
	^ self helpers at: #axannouncer! !

!WASession methodsFor: '*js-helpers-override' stamp: 'kph 10/30/2007 03:39'!
baseUrl
	^ self application baseUrl! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 10/27/2007 21:28'!
comet
	^ self helpers at: #comet ifAbsent: nil! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 10/27/2007 18:25'!
expire
	"we unregister the helpers at expire time, rather than waiting for the session to be cleaned up later"
	self helpers unregistered! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 11/18/2007 19:15'!
finalize

	^ self unregistered! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 10/27/2007 22:53'!
helpers
	"shh dont tell anyone"
	^ parent! !

!WASession methodsFor: '*js-helpers-override' stamp: 'kph 12/8/2007 03:20'!
incomingRequest: aRequest
 	
	(self helpers incomingRequest: aRequest in: self) ifNotNilDo: [ :response | ^ response ].
 	
	((aRequest fields includesKey: 'terminate')
		and: [(self application deploymentMode not or: [ self showToolbarHelper ])])
			ifTrue: [
				monitor terminate.
				^ WAResponse new nextPutAll: 'Process terminated' ].
	^ monitor
		critical: [ self responseForRequest: aRequest ]
		ifError: [ :error | self errorHandler internalError: error ]
		
	 ! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 12/8/2007 06:20'!
postProcessRequest: aRequest returned: aResponse

	monitor
		critical: [ self helpers postProcessRequest: aRequest returned: aResponse ]
		ifError: [ :error | self log error: error ]
		
	
! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 10/27/2007 22:56'!
properties

	"our extension to WASession provides an IdentityDictionary for storing Property values"

	"shh dont tell anyone"
	^ parent! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 12/11/2007 10:25'!
registerForFinalization
	
	self finalizationRegistry add: self executor:  self executor..! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 12/8/2007 05:19'!
registerPusher: aPusher context: aContext

	"CTComet could be changed to send this, in order that this method be removed from WASession"
	^ self comet registerPusher: aPusher context: aContext! !

!WASession methodsFor: '*js-helpers-override' stamp: 'kph 12/9/2007 05:30'!
responseForRequest: aRequest
	| response |
	currentRequest := aRequest.
	response := self helpers responseForRequest: aRequest wrap: [  self withEscapeContinuation: [
		WACurrentSession
			use: self
			during: [
				self withErrorHandler: [
					self performRequest: aRequest ] ] ]].
	
	response headerAt: 'Session' put: (self application ensureKeyForHandler: self) printString.
	
	^ response! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 10/31/2007 04:17'!
rootComponent

	^ lastContinuation root! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 12/11/2007 15:56'!
setParent: aRequestHandler
	
	parent := WASessionHelpers parent: aRequestHandler session: self.
	parent initialize.		 ! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 11/10/2007 00:54'!
showToolbarHelper
	
	^ self properties at: #showToolbarhelper ifAbsent: [ false ] ! !

!WASession methodsFor: '*js-helpers' stamp: 'kph 11/10/2007 01:03'!
showToolbarHelper: aBool
	
	self properties at: #showToolbarhelper put: aBool! !

!WASession methodsFor: '*js-helpers-override' stamp: 'lr 10/28/2007 14:42'!
start: aRequest
	self useSessionCookie
		ifTrue: [ self redirectWithCookie: self sessionCookie ].
	^ self mainClass new start: aRequest! !

!WASession methodsFor: '*js-helpers-override' stamp: 'lr 4/15/2007 15:55'!
unregistered
	super unregistered.
	self expire! !

!WARegistry methodsFor: '*js-helpers' stamp: 'kph 10/31/2007 04:11'!
handlersByKey

	^ handlersByKey! !

!WARegistry methodsFor: '*js-helpers' stamp: 'kph 12/8/2007 05:14'!
postProcessRequest: aRequest returned: aResponse

	self subclassResponsibility! !
